
! CÁLCULO DO NÚMERO PI

! PI = 4/1 - 4/3 + 4/5 - 4/7 + 4/9 - 4/11 + 4/13 - 4/15 + 4/17 - 4/19 + .......

 SUBROUTINE CAL_PI(N)

 USE OMP_LIB
 
 IMPLICIT NONE

 !DECLARAÇÃO DAS VARIÁVEIS GLOBAIS
 INTEGER(8),INTENT(IN) ::N
 
 !DECLARAÇÃO DAS VARIÁVEIS LOCAIS
 INTEGER(8)		::I
 REAL			::FINISH,START,TEMPO_SEQ,TEMPO_PAR
 DOUBLE PRECISION	::NUM_PI_SEQ,NUM_PI_PAR

 
 

!SEQUENCIAL
  
 START = OMP_GET_WTIME() 
 
 NUM_PI_SEQ = 0.0 
     
    DO I = 1,N/2
    
	NUM_PI_SEQ = NUM_PI_SEQ +  4.0 / (4.0 * (i-1) + 1.0 ) 
	
	NUM_PI_SEQ = NUM_PI_SEQ -  4.0 / (4.0 * (i-1) + 3.0 )

    END DO

 FINISH = OMP_GET_WTIME()
 
 TEMPO_SEQ = FINISH - START
 
 
 
 
 
 ! PARALELO

 START = OMP_GET_WTIME() 
  
 NUM_PI_PAR = 0.0 
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!            
 !$OMP PARALLEL DO REDUCTION (+:NUM_PI_PAR)
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    DO I = 1,N/2
    
	NUM_PI_PAR = NUM_PI_PAR +  4.0 / (4.0 * (i-1) + 1.0 ) 
	
	NUM_PI_PAR = NUM_PI_PAR -  4.0 / (4.0 * (i-1) + 3.0 )

    END DO
    
 !!!!!!!!!!!!!!!!!!!!!
 !$OMP END PARALLEL DO
 !!!!!!!!!!!!!!!!!!!!!
 
 FINISH = OMP_GET_WTIME()
 
 TEMPO_PAR = FINISH - START
 
 
 
 
 OPEN (1, FILE='NUMERO_PI.dat', STATUS='UNKNOWN')

 WRITE(1,*)'O NÚMERO PI EH (CODIGO SEQUENCIAL)', NUM_PI_SEQ
 
 WRITE(1,10) TEMPO_SEQ
 
 WRITE(1,*)' '
 WRITE(1,*)' '
 
 WRITE(1,*)'O NÚMERO PI EH (CODIGO PARALELO)', NUM_PI_PAR
 
 WRITE(1,10) TEMPO_PAR

 10 FORMAT(' TEMPO DE EXECUCAO = ',F40.30,' SEGUNDOS')
 
 END SUBROUTINE CAL_PI