
 ! DEFINIÇÃO SOMA E MULTIPLICAÇÃO ENTRE MATRIZES
 
 SUBROUTINE PRODUTOINTERNO(N)

 USE OMP_LIB 
 
 IMPLICIT NONE
 
 !DECLARAÇÃO DAS VARIÁVEIS GLOBAIS
 INTEGER(8),INTENT(IN) ::N
 
 !DECLARAÇÃO DAS VARIÁVEIS LOCAIS
 INTEGER(8)					::I,CHUNK
 REAL*16					::START,FINISH,TEMPO_SEQ,TEMPO_PAR
 REAL*16					::S,SS
 DOUBLE PRECISION,DIMENSION(:),ALLOCATABLE 	::A,B

 
 ALLOCATE(A(N),B(N))
 
 
 
 !SEQUENCIAL
 
 START = OMP_GET_WTIME()

 DO I = 1,N
    
    A(I) = I * 1.0
    
    B(I) = A(I)**(1.0/(I*1.0))

 END DO
     
 S = 0.0
 
 DO I = 1,N
  
    S = S + A(I) * B(I) 

 END DO

    
 FINISH = OMP_GET_WTIME()
 
 TEMPO_SEQ = FINISH - START
    
 
 
 
 
 
 
 ! PARALELO
 
 START = OMP_GET_WTIME() 
 
 !!!!!!!!
 !$OMP DO  
 !!!!!!!!

 DO I = 1,N
    
    A(I) = I * 1.0
    
    B(I) = A(I)**(1.0/(I*1.0))

 END DO
	    
 !!!!!!!!!!!!
 !$OMP END DO
 !!!!!!!!!!!!
	    
 CHUNK = N/4    
 
 SS = 0.0	    
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !$OMP PARALLEL DO SCHEDULE(STATIC,CHUNK) REDUCTION(+:SS) 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
 DO I = 1,N
				    
    SS = SS + A(I) * B(I)
 
 END DO
    
 !!!!!!!!!!!!!!!!!!!!!
 !$OMP END PARALLEL DO
 !!!!!!!!!!!!!!!!!!!!!

 
 FINISH = OMP_GET_WTIME()
 
 TEMPO_PAR = FINISH - START

 
 
 OPEN (1, FILE='PRODUTO_INTERNO.dat', STATUS='UNKNOWN')

 WRITE(1,*)'A SOMA DAS COMPONENTES DO VETOR EH (CODIGO SEQUENCIAL)', S
 
 WRITE(1,10) TEMPO_SEQ
 
 WRITE(1,*)' '
 WRITE(1,*)' '
 
 WRITE(1,*)'A SOMA DAS COMPONENTES DO VETOR EH (CODIGO PARALELO)  ', SS
 
 WRITE(1,10) TEMPO_PAR

 10 FORMAT(' TEMPO DE EXECUCAO = ',F100.70,' SEGUNDOS')
 
 

 
 END SUBROUTINE PRODUTOINTERNO
 
 