
 SUBROUTINE SEQUENCIAL(N)

 IMPLICIT NONE

 !DECLARAÇÃO DAS VARIÁVEIS GLOBAIS
 INTEGER,INTENT(IN) ::N
 
 !DECLARAÇÃO DAS VARIÁVEIS LOCAIS
 INTEGER					::I,J,K
 REAL						::PROD,S,start, finish
 DOUBLE PRECISION,DIMENSION(:,:),ALLOCATABLE 	::MATRIZ,SOMA,TMATRIZ,PRODUTO

 
 CALL CPU_TIME(start)
 
 ALLOCATE(MATRIZ(N,N),SOMA(N,N),TMATRIZ(N,N),PRODUTO(N,N))

 
  
	! DEFINIÇÃO DA MATRIZ
	S = 0.0
	DO I = 1,N
	    DO J = 1,N
		S = S + 1.0
		MATRIZ(I,J) = S
	    END DO
	END DO
	
	! SOMA DE MATRIZES
	DO I = 1,N
	    DO J = 1,N
		SOMA(I,J) = MATRIZ(I,J) + MATRIZ(I,J)
	    END DO
	END DO

	! PRODUTO DE MATRIZES
	
	TMATRIZ = TRANSPOSE(MATRIZ)
	
	DO I = 1,N
	    DO J = 1,N
		PROD = 0.0
		DO K = 1,N
		    PROD = PROD + MATRIZ(I,K)*TMATRIZ(K,J)
		END DO 
		PRODUTO(I,J) = PROD
	    END DO
	END DO
	
 
 OPEN (1, FILE='MATRIZ-seq.dat', STATUS='UNKNOWN')
 OPEN (2, FILE='SOMA-seq.dat', STATUS='UNKNOWN')
 OPEN (3, FILE='PRODUTO-seq.dat', STATUS='UNKNOWN')

 
 
 WRITE(1,*)'#         I           J           MATRIZ(I,J)'
 WRITE(2,*)'#         I           J           SOMA(I,J)'
 WRITE(3,*)'#         I           J           PRODUTO(I,J)'
 
 DO I = 1,N
    DO J = 1,N
        WRITE(1,*)I , J ,  MATRIZ(I,J)
        WRITE(2,*)I , J ,    SOMA(I,J)
        WRITE(3,*)I , J , PRODUTO(I,J)
    END DO
 END DO
 
 CALL CPU_TIME(finish)
 print '("TEMPO = ",f6.3," SEGUNDOS (codigo-sequencial).")',finish-start

 
 END SUBROUTINE SEQUENCIAL