
 ! DEFINIÇÃO SOMA E MULTIPLICAÇÃO ENTRE MATRIZES
 
 SUBROUTINE SOMAPRODUTO(N)

 USE OMP_LIB 
 
 IMPLICIT NONE
 
 !DECLARAÇÃO DAS VARIÁVEIS GLOBAIS
 INTEGER(8),INTENT(IN) ::N
 
 !DECLARAÇÃO DAS VARIÁVEIS LOCAIS
 INTEGER(8)					::I,J,K
 REAL						::PROD,S,START,FINISH,TEMPO_SEQ,TEMPO_PAR
 DOUBLE PRECISION,DIMENSION(:,:),ALLOCATABLE 	::MATRIZ,SOMA,TMATRIZ,PRODUTO

 


 
 ALLOCATE(MATRIZ(N,N),SOMA(N,N),TMATRIZ(N,N),PRODUTO(N,N))


!SEQUENCIAL
 
 START = OMP_GET_WTIME()
 
 ! DEFINIÇÃO DA MATRIZ
 S = 0.0
 DO I = 1,N
    DO J = 1,N
	S = S + 1.0
	MATRIZ(I,J) = S
    END DO
 END DO
	

 ! SOMA DE MATRIZES
 DO I = 1,N
    DO J = 1,N
	SOMA(I,J) = MATRIZ(I,J) + MATRIZ(I,J)
    END DO
 END DO

 
! PRODUTO DE MATRIZES
 TMATRIZ = TRANSPOSE(MATRIZ)
 DO I = 1,N
    DO J = 1,N
	PROD = 0.0
	DO K = 1,N
	    PROD = PROD + MATRIZ(I,K)*TMATRIZ(K,J)
	END DO 
	PRODUTO(I,J) = PROD
    END DO
 END DO

 
 OPEN (1, FILE='MATRIZ-seq.dat', STATUS='UNKNOWN')
 WRITE(1,*)'#         I           J           MATRIZ(I,J)'

 OPEN (2, FILE='SOMA-seq.dat', STATUS='UNKNOWN')
 WRITE(2,*)'#         I           J           SOMA(I,J)'

 OPEN (3, FILE='PRODUTO-seq.dat', STATUS='UNKNOWN')
 WRITE(3,*)'#         I           J           PRODUTO(I,J)'
 
 DO I = 1,N
    DO J = 1,N
      WRITE(1,*)I , J ,  MATRIZ(I,J)
      WRITE(2,*)I , J ,    SOMA(I,J)
      WRITE(3,*)I , J , PRODUTO(I,J)
    END DO
 END DO

 
 FINISH = OMP_GET_WTIME()
 
 TEMPO_SEQ = FINISH - START

 
 
 
 
 
 ! PARALELO

 START = OMP_GET_WTIME() 
  

 ! DEFINIÇÃO DA MATRIZ

 S = 0.0

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !$OMP DO PRIVATE(J) 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    DO I = 1,N
	DO J = 1,N
	    S = S + 1.0
	    MATRIZ(I,J) = S
	END DO
    END DO

 !!!!!!!!!!!!
 !$OMP END DO
 !!!!!!!!!!!!
    
 OPEN (4, FILE='MATRIZ-par.dat', STATUS='UNKNOWN')
 WRITE(4,*)'#         I           J           MATRIZ(I,J)'

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !$OMP DO PRIVATE(J)
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	    
    DO I = 1,N
	DO J = 1,N
	    WRITE(4,*)I , J ,  MATRIZ(I,J)
	END DO
    END DO

 !!!!!!!!!!!!
 !$OMP END DO
 !!!!!!!!!!!!

 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !$OMP SECTIONS PRIVATE(I,J,K)
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     
      !!!!!!!!!!!!!
      !$OMP SECTION
      !!!!!!!!!!!!!
 
	  ! SOMA DE MATRIZES
	  DO I = 1,N
	      DO J = 1,N
		  SOMA(I,J) = MATRIZ(I,J) + MATRIZ(I,J)
	      END DO
	  END DO

	
	OPEN (5, FILE='SOMA-par.dat', STATUS='UNKNOWN')
	WRITE(5,*)'#         I           J           SOMA(I,J)'
	DO I = 1,N
	    DO J = 1,N
		WRITE(5,*)I , J ,    SOMA(I,J)
	    END DO
	END DO
	
      !!!!!!!!!!!!!    
      !$OMP SECTION
      !!!!!!!!!!!!!
      
	! PRODUTO DE MATRIZES
	TMATRIZ = TRANSPOSE(MATRIZ)
	DO I = 1,N
	    DO J = 1,N
		PROD = 0.0
		DO K = 1,N
		    PROD = PROD + MATRIZ(I,K)*TMATRIZ(K,J)
		END DO 
		PRODUTO(I,J) = PROD
	    END DO
	END DO

	OPEN (6, FILE='PRODUTO-par.dat', STATUS='UNKNOWN')
	WRITE(6,*)'#         I           J           PRODUTO(I,J)'
	
	DO I = 1,N
	    DO J = 1,N
		WRITE(6,*)I , J , PRODUTO(I,J)
	    END DO
	END DO
	    
 !!!!!!!!!!!!!!!!!!   
 !$OMP END SECTIONS 
 !!!!!!!!!!!!!!!!!!
 
 FINISH = OMP_GET_WTIME()
 
 TEMPO_PAR = FINISH - START
 
 
 
 OPEN (10, FILE='SOMAPRODUTOMATRIZES.dat', STATUS='UNKNOWN')
 
 WRITE(10,*)'CODIGO SEQUENCIAL'
 
 WRITE(10,10) TEMPO_SEQ
 
 WRITE(10,*)' '
 WRITE(10,*)' '
 
 WRITE(10,*)'CODIGO PARALELO'
 
 WRITE(10,10) TEMPO_PAR

 10 FORMAT(3X,' TEMPO DE EXECUCAO = ',F20.8,' SEGUNDOS')

 
 END SUBROUTINE SOMAPRODUTO